﻿using System;
using System.Windows;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            this.button.Click += button_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 버튼 클릭시 처리하기 - button_Click(sender, e)

        /// <summary>
        /// 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void button_Click(object sender, RoutedEventArgs e)
        {
            this.listBox.Items.Add($"[{DateTime.Now.ToString("HH:mm:ss")}] 버튼을 클릭했습니다.");

            DeferredAction deferredAction = DeferredAction.Create
            (
                context =>
                {
                    this.listBox.Items.Add($"[{DateTime.Now.ToString("HH:mm:ss")}] 작업을 실행했습니다.");

                    context.Dispose();
                }
            );

            deferredAction.Defer(TimeSpan.FromSeconds(3));
        }

        #endregion
    }
}